diff -r 5e0d53cac617 trytond/modules/purchase/purchase.py
--- a/trytond/modules/purchase/purchase.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -608,260 +515,244 @@
         default['invoices_ignored'] = None
         default['shipment_state'] = 'none'
         default.setdefault('purchase_date', None)
-        return super(Purchase, self).copy(ids, default=default)
+        return super(Purchase, cls).copy(purchases, default=default)
 
-    def check_for_quotation(self, ids):
-        purchases = self.browse(ids)
-        for purchase in purchases:
-            if not purchase.invoice_address:
-                self.raise_user_error('invoice_addresse_required')
-            for line in purchase.lines:
-                if (not line.to_location
-                        and line.product
-                        and line.product.type in ('goods', 'assets')):
-                    self.raise_user_error('warehouse_required')
+    def check_for_quotation(self):
+        if not self.invoice_address:
+            self.raise_user_error('invoice_addresse_required')
+        for line in self.lines:
+            if (not line.to_location
+                    and line.product
+                    and line.product.type in ('goods', 'assets')):
+                self.raise_user_error('warehouse_required')
 
-    def set_reference(self, ids):
+    @classmethod
+    def set_reference(cls, purchases):
         '''
         Fill the reference field with the purchase sequence
         '''
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('purchase.configuration')
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('purchase.configuration')
 
-        config = config_obj.browse(1)
-        purchases = self.browse(ids)
+        config = Config(1)
         for purchase in purchases:
             if purchase.reference:
                 continue
-            reference = sequence_obj.get_id(config.purchase_sequence.id)
-            self.write(purchase.id, {
-                'reference': reference,
-                })
-
-    def set_purchase_date(self, ids):
-        date_obj = Pool().get('ir.date')
-        for purchase in self.browse(ids):
-            if not purchase.purchase_date:
-                self.write(purchase.id, {
-                    'purchase_date': date_obj.today(),
+            reference = Sequence.get_id(config.purchase_sequence.id)
+            cls.write([purchase], {
+                    'reference': reference,
                     })
 
-    def store_cache(self, ids):
-        for purchase in self.browse(ids):
-            self.write(purchase.id, {
+    @classmethod
+    def set_purchase_date(cls, purchases):
+        Date = Pool().get('ir.date')
+        for purchase in purchases:
+            if not purchase.purchase_date:
+                cls.write([purchase], {
+                        'purchase_date': Date.today(),
+                        })
+
+    @classmethod
+    def store_cache(cls, purchases):
+        for purchase in purchases:
+            cls.write([purchase], {
                     'untaxed_amount_cache': purchase.untaxed_amount,
                     'tax_amount_cache': purchase.tax_amount,
                     'total_amount_cache': purchase.total_amount,
                     })
 
-    def _get_invoice_line_purchase_line(self, purchase):
+    def _get_invoice_line_purchase_line(self):
         '''
-        Return invoice line values for each purchase lines
-
-        :param purchase: a BrowseRecord of the purchase
-        :return: a dictionary with invoiced purchase line id as key
-            and a list of invoice line values as value
+        Return invoice line for each purchase lines
         '''
-        line_obj = Pool().get('purchase.line')
         res = {}
-        for line in purchase.lines:
-            val = line_obj.get_invoice_line(line)
+        for line in self.lines:
+            val = line.get_invoice_line()
             if val:
                 res[line.id] = val
         return res
 
-    def _get_invoice_purchase(self, purchase):
+    def _get_invoice_purchase(self):
         '''
-        Return invoice values for purchase
-
-        :param purchase: the BrowseRecord of the purchase
-
-        :return: a dictionary with purchase fields as key and
-            purchase values as value
-        '''
-        journal_obj = Pool().get('account.journal')
-
-        journal_id = journal_obj.search([
-            ('type', '=', 'expense'),
-            ], limit=1)
-        if journal_id:
-            journal_id = journal_id[0]
-
-        res = {
-            'company': purchase.company.id,
-            'type': 'in_invoice',
-            'reference': purchase.reference,
-            'journal': journal_id,
-            'party': purchase.party.id,
-            'invoice_address': purchase.invoice_address.id,
-            'currency': purchase.currency.id,
-            'account': purchase.party.account_payable.id,
-            'payment_term': purchase.payment_term.id,
-        }
-        return res
-
-    def create_invoice(self, purchase):
-        '''
-        Create an invoice for the purchase and return the id
+        Return invoice
         '''
         pool = Pool()
-        invoice_obj = pool.get('account.invoice')
-        invoice_line_obj = pool.get('account.invoice.line')
-        purchase_line_obj = pool.get('purchase.line')
+        Journal = pool.get('account.journal')
+        Invoice = pool.get('account.invoice')
 
-        if purchase.invoice_method == 'manual':
+        journals = Journal.search([
+                ('type', '=', 'expense'),
+                ], limit=1)
+        if journals:
+            journal, = journals
+        else:
+            journal = None
+
+        with Transaction().set_user(0, set_context=True):
+            return Invoice(
+                company=self.company,
+                type='in_invoice',
+                reference=self.reference,
+                journal=journal,
+                party=self.party,
+                invoice_address=self.invoice_address,
+                currency=self.currency,
+                account=self.party.account_payable,
+                payment_term=self.payment_term,
+                )
+
+    def create_invoice(self):
+        '''
+        Create an invoice for the purchase and return it
+        '''
+        pool = Pool()
+        Invoice = pool.get('account.invoice')
+        PurchaseLine = pool.get('purchase.line')
+
+        if self.invoice_method == 'manual':
             return
 
-        if not purchase.party.account_payable:
+        if not self.party.account_payable:
             self.raise_user_error('missing_account_payable',
-                    error_args=(purchase.party.rec_name,))
+                    error_args=(self.party.rec_name,))
 
-        invoice_lines = self._get_invoice_line_purchase_line(purchase)
+        invoice_lines = self._get_invoice_line_purchase_line()
         if not invoice_lines:
             return
 
-        vals = self._get_invoice_purchase(purchase)
-        with Transaction().set_user(0, set_context=True):
-            invoice_id = invoice_obj.create(vals)
+        invoice = self._get_invoice_purchase()
+        invoice.save()
 
-        for line in purchase.lines:
+        for line in self.lines:
             if line.id not in invoice_lines:
                 continue
-            for vals in invoice_lines[line.id]:
-                vals['invoice'] = invoice_id
-                with Transaction().set_user(0, set_context=True):
-                    invoice_line_id = invoice_line_obj.create(vals)
-                purchase_line_obj.write(line.id, {
-                    'invoice_lines': [('add', invoice_line_id)],
-                    })
+            for invoice_line in invoice_lines[line.id]:
+                invoice_line.invoice = invoice.id
+                invoice_line.save()
+                PurchaseLine.write([line], {
+                        'invoice_lines': [('add', [invoice_line.id])],
+                        })
 
         with Transaction().set_user(0, set_context=True):
-            invoice_obj.update_taxes([invoice_id])
+            Invoice.update_taxes([invoice])
 
-        self.write(purchase.id, {
-            'invoices': [('add', invoice_id)],
-        })
-        return invoice_id
+        self.write([self], {
+                'invoices': [('add', [invoice.id])],
+                })
+        return invoice
 
-    def create_move(self, purchase):
+    def create_move(self):
         '''
         Create move for each purchase lines
         '''
-        line_obj = Pool().get('purchase.line')
+        for line in self.lines:
+            line.create_move()
 
-        for line in purchase.lines:
-            line_obj.create_move(line)
+    def is_done(self):
+        return ((self.invoice_state == 'paid'
+                or self.invoice_method == 'manual')
+            and self.shipment_state == 'received')
 
-    def is_done(self, purchase):
-        return ((purchase.invoice_state == 'paid'
-                or purchase.invoice_method == 'manual')
-            and purchase.shipment_state == 'received')
+    @classmethod
+    def delete(cls, purchases):
+        # Cancel before delete
+        cls.cancel(purchases)
+        for purchase in purchases:
+            if purchase.state != 'cancel':
+                cls.raise_user_error('delete_cancel', purchase.rec_name)
+        super(Purchase, cls).delete(purchases)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        # Cancel before delete
-        self.cancel(ids)
-        for purchase in self.browse(ids):
-            if purchase.state != 'cancel':
-                self.raise_user_error('delete_cancel', purchase.rec_name)
-        return super(Purchase, self).delete(ids)
-
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        self.store_cache(ids)
+    def cancel(cls, purchases):
+        cls.store_cache(purchases)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
+    def draft(cls, purchases):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('quotation')
-    def quote(self, ids):
-        self.check_for_quotation(ids)
-        self.set_reference(ids)
+    def quote(cls, purchases):
+        for purchase in purchases:
+            purchase.check_for_quotation()
+        cls.set_reference(purchases)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('confirmed')
-    def confirm(self, ids):
-        self.set_purchase_date(ids)
-        self.store_cache(ids)
-        self.process(ids)
+    def confirm(cls, purchases):
+        cls.set_purchase_date(purchases)
+        cls.store_cache(purchases)
+        cls.process(purchases)
 
+    @classmethod
     @ModelView.button_action('purchase.wizard_invoice_handle_exception')
-    def handle_invoice_exception(self, ids):
+    def handle_invoice_exception(cls, purchases):
         pass
 
+    @classmethod
     @ModelView.button_action('purchase.wizard_shipment_handle_exception')
-    def handle_shipment_exception(self, ids):
+    def handle_shipment_exception(cls, purchases):
         pass
 
-    def process(self, ids):
+    @classmethod
+    def process(cls, purchases):
         done = []
-        for purchase in self.browse(ids):
+        for purchase in purchases:
             if purchase.state in ('done', 'cancel'):
                 continue
-            self.create_invoice(purchase)
-            self.set_invoice_state(purchase)
-            self.create_move(purchase)
-            self.set_shipment_state(purchase)
-            if self.is_done(purchase):
-                done.append(purchase.id)
+            purchase.create_invoice()
+            purchase.set_invoice_state()
+            purchase.create_move()
+            purchase.set_shipment_state()
+            if purchase.is_done():
+                done.append(purchase)
         if done:
-            self.write(done, {
+            cls.write(done, {
                     'state': 'done',
                     })
 
-Purchase()
-
 
 class PurchaseInvoice(ModelSQL):
     'Purchase - Invoice'
-    _name = 'purchase.purchase-account.invoice'
+    __name__ = 'purchase.purchase-account.invoice'
     _table = 'purchase_invoices_rel'
-    _description = __doc__
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-PurchaseInvoice()
 
-
-class PuchaseIgnoredInvoice(ModelSQL):
+class PurchaseIgnoredInvoice(ModelSQL):
     'Purchase - Ignored Invoice'
-    _name = 'purchase.purchase-ignored-account.invoice'
+    __name__ = 'purchase.purchase-ignored-account.invoice'
     _table = 'purchase_invoice_ignored_rel'
-    _description = __doc__
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-PuchaseIgnoredInvoice()
-
 
 class PurchaseRecreadtedInvoice(ModelSQL):
     'Purchase - Recreated Invoice'
-    _name = 'purchase.purchase-recreated-account.invoice'
+    __name__ = 'purchase.purchase-recreated-account.invoice'
     _table = 'purchase_invoice_recreated_rel'
-    _description = __doc__
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     invoice = fields.Many2One('account.invoice', 'Invoice',
             ondelete='RESTRICT', select=True, required=True)
 
-PurchaseRecreadtedInvoice()
-
 
 class PurchaseLine(ModelSQL, ModelView):
     'Purchase Line'
-    _name = 'purchase.line'
+    __name__ = 'purchase.line'
     _rec_name = 'description'
-    _description = __doc__
-
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     sequence = fields.Integer('Sequence',
@@ -898,7 +789,7 @@
             '_parent_purchase.party'],
         depends=['product', 'type', 'product_uom_category'])
     unit_digits = fields.Function(fields.Integer('Unit Digits',
-        on_change_with=['unit']), 'get_unit_digits')
+            on_change_with=['unit']), 'on_change_with_unit_digits')
     product = fields.Many2One('product.product', 'Product',
         domain=[('purchasable', '=', True)],
         states={
@@ -920,7 +811,7 @@
     product_uom_category = fields.Function(
         fields.Many2One('product.uom.category', 'Product Uom Category',
             on_change_with=['product']),
-        'get_product_uom_category')
+        'on_change_with_product_uom_category')
     unit_price = fields.Numeric('Unit Price', digits=(16, 4),
         states={
             'invisible': Eval('type') != 'line',
@@ -960,12 +851,13 @@
     delivery_date = fields.Function(fields.Date('Delivery Date',
             on_change_with=['product', '_parent_purchase.purchase_date',
                 '_parent_purchase.party']),
-        'get_delivery_date')
+        'on_change_with_delivery_date')
 
-    def __init__(self):
-        super(PurchaseLine, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(PurchaseLine, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._error_messages.update({
             'supplier_location_required': 'The supplier location is required!',
             'missing_account_expense': 'It misses ' \
                     'an "Account Expense" on product "%s"!',
